﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using CSharpCTI;

namespace TestDemoForm
{
    /// <summary>
    /// 测试画面
    /// </summary>
    public partial class TestForm : Form
    {
        /// <summary>
        /// 测试画面构造函数
        /// </summary>
        public TestForm()
        {
            InitializeComponent();
        }
        private Label[] labels;
        private TextBox[] textboxs;
        private List<ActionListItem> actions = new List<ActionListItem>();
        private CSharpEvent watchEvent;
        CSharpCTIHelper WatchHelper; 
        /// <summary>
        /// 提交按钮按下
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSubmit_Click(object sender, EventArgs e)
        {
            try
            {
                Submit();
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        
        /// <summary>
        /// 加载Action
        /// </summary>
        private void ListViewSet()
        {
            string ActionName = string.Empty;
            foreach (FieldInfo field in typeof(CSharpCTI.CSharpCTIActionName).GetFields())
            {
                ActionName = field.Name + "Action";
                ListActions.Items.Add(ActionName);
            }
            CreatControl();
        }
        /// <summary>
        /// 选择Action变化
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ListActions_SelectedIndexChanged(object sender, EventArgs e)
        {
            int count=0;
            string FullActionName= ListActions.SelectedItem.ToString();
            object action = Activator.CreateInstance(Type.GetType("CSharpCTI.Actions." + FullActionName + ", CSharpCTI, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null"));
            
            string actionName= FullActionName.ToLower().Remove(FullActionName.Length-"action".Length);
            ActionListItem actionitem = actions.Find((ActionListItem s) => s.actionName == actionName);
            labActionName.Text = actionitem.actionChinsesName;
            foreach (FieldInfo field in action.GetType().GetFields())
            {

                Item item = actionitem.data.Find((Item s) => s.itemName == field.Name);
                
                labels[count].Text = field.Name;
                labels[count].Visible = true;
                textboxs[count].Text = "";
                textboxs[count].Visible = true;
                if (item.request)
                {
                    labels[count].ForeColor = Color.Red;
                }
                else
                {
                    labels[count].ForeColor = Color.Black;
                }
                count++;
            }
            while (count < 25)
            {
                
                labels[count].Text ="";
                labels[count].Visible = false;
                textboxs[count].Text = "";
                textboxs[count].Visible = false;
                count++;
            }
        }
        /// <summary>
        /// 控件数组加载
        /// </summary>
        private void CreatControl()
        {
            textboxs = new TextBox[25];
            labels = new Label[25];
            textboxs[0] = textBox1;
            textboxs[1] = textBox2;
            textboxs[2] = textBox3;
            textboxs[3] = textBox4;
            textboxs[4] = textBox5;
            textboxs[5] = textBox6;
            textboxs[6] = textBox7;
            textboxs[7] = textBox8;
            textboxs[8] = textBox9;
            textboxs[9] = textBox10;
            textboxs[10] = textBox11;
            textboxs[11] = textBox12;
            textboxs[12] = textBox13;
            textboxs[13] = textBox14;
            textboxs[14] = textBox15;
            textboxs[15] = textBox16;
            textboxs[16] = textBox17;
            textboxs[17] = textBox18;
            textboxs[18] = textBox19;
            textboxs[19] = textBox20;
            textboxs[20] = textBox21;
            textboxs[21] = textBox22;
            textboxs[22] = textBox23;
            textboxs[23] = textBox24;
            textboxs[24] = textBox25;

            labels[0] = label1;
            labels[1] = label2;
            labels[2] = label3;
            labels[3] = label4;
            labels[4] = label5;
            labels[5] = label6;
            labels[6] = label7;
            labels[7] = label8;
            labels[8] = label9;
            labels[9] = label10;
            labels[10] = label11;
            labels[11] = label12;
            labels[12] = label13;
            labels[13] = label14;
            labels[14] = label15;
            labels[15] = label16;
            labels[16] = label17;
            labels[17] = label18;
            labels[18] = label19;
            labels[19] = label20;
            labels[20] = label21;
            labels[21] = label22;
            labels[22] = label23;
            labels[23] = label24;
            labels[24] = label25;
       }
        /// <summary>
        /// 画面启动
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void TestForm_Load(object sender, EventArgs e)
        {
            ListViewSet();
            CreatControl();
            
            textBoxIP.Text = "192.168.0.117";
            textBoxPort.Text = "80";
            textBoxwebkey.Text = "be936b2a75f01891";
            textInterval.Text = "1000";
            string json = new System.IO.StreamReader( Environment.CurrentDirectory+"\\入力信息Json.txt", Encoding.Unicode).ReadToEnd();
            actions = Newtonsoft.Json.JsonConvert.DeserializeObject<List<ActionListItem>>(json);
            ListActions.SelectedIndex = 0;
            LabelMessage.Text = "红色标题项为必须输入的内容！";
            watchEvent=new CSharpEvent(this);
            watchEvent.EventDelegate += ServerWatch;

        }
        /// <summary>
        /// 提交信息
        /// </summary>
        private void Submit()
        {
            CSharpCTIHelper helper = new CSharpCTI.CSharpCTIHelper(textBoxIP.Text, textBoxPort.Text, textBoxwebkey.Text, 500, null, null);
            string MethodName = "send" + ListActions.SelectedItem;
            MethodInfo submitMethod = helper.GetType().GetMethod(MethodName);
            object action = Activator.CreateInstance(Type.GetType("CSharpCTI.Actions." + ListActions.SelectedItem.ToString() + ", CSharpCTI, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null"));
            for (int i = 0; i < 25; i++)
            {
                if (labels[i].Visible )
                {
                    FieldInfo field= action.GetType().GetField(labels[i].Text);
                    field.SetValue(action, textboxs[i].Text);
                    if (labels[i].Text.Equals("filename") || labels[i].Text.Equals("filename"))
                    { 
                    
                    }
                }
            }
            object[] methodIn = new object[1];
            methodIn[0] = action;
            object resultObject = submitMethod.Invoke(helper, methodIn);
            FieldInfo MusicFilid = resultObject.GetType().GetField("FileResult");
            if (MusicFilid != null)
            {
                if (MusicFilid.GetValue(resultObject)!=null)
                {
                    if (MusicFilid.GetValue(resultObject).ToString()!= "")
                    {
                        byte[] bytes = (byte[])MusicFilid.GetValue(resultObject);
                        string path = Environment.CurrentDirectory + "\\";
                        string FileName = "下载音频文件.WAV";
                        if (ListActions.SelectedItem.Equals("GetFaxAction"))
                        {
                            FileName = "下载传真文件.tiff";
                        }
                       
                        System.IO.File.WriteAllBytes(path + FileName, bytes);
                        result.Text = @"文件作成成功，生成文件路径为："+path+ FileName ;
                        return;
                    }
                }
            }
            result.Text = Newtonsoft.Json.JsonConvert.SerializeObject(resultObject);
        }
        /// <summary>
        /// 输入文本框进去是显示提示
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void InputTextBox_Enter(object sender, EventArgs e)
        {
            int index = int.Parse(((TextBox)sender).Tag.ToString()) ;
            string FullActionName = ListActions.SelectedItem.ToString();
            string actionName = FullActionName.ToLower().Remove(FullActionName.Length - "action".Length);
            ActionListItem actionitem = actions.Find((ActionListItem s) => s.actionName == actionName);
            string fieldName = labels[index - 1].Text ;
            Item item = actionitem.data.Find((Item s) => s.itemName == fieldName);
            LabelMessage.Text = item.itemChinese;
        }
        /// <summary>
        /// 输入区域离开时提示
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void inputGroup_Leave(object sender, EventArgs e)
        {
            LabelMessage.Text = "红色标题项为必须输入的内容！";
        }

        /// <summary>
        /// 监视返回事件
        /// </summary>
        /// <param name="message"></param>
        private void  ServerWatch(string message)
        {
            textEventResult.Text += message + Environment.NewLine;
            textEventResult.SelectionStart  = textEventResult.TextLength ;
            textEventResult.ScrollToCaret();
        }
        /// <summary>
        /// 监视开始按钮
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnWatchStart_Click(object sender, EventArgs e)
        {
            int Interval;
            if (!int.TryParse(textInterval.Text,out Interval))
            {
                Interval = 1000;
            }
            WatchHelper = new CSharpCTI.CSharpCTIHelper(textBoxIP.Text, textBoxPort.Text, textBoxwebkey.Text,Interval, null, watchEvent);     
            WatchHelper.start();
        }
       
        /// <summary>
        /// 监视终止按钮
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnWatchStop_Click(object sender, EventArgs e)
        {
            if (WatchHelper != null)
            {
                WatchHelper.stop();
            }
        }
        /// <summary>
        /// 监视内容清屏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnWatchClear_Click(object sender, EventArgs e)
        {
            textEventResult.Text = "";
        }
        /// <summary>
        /// UTF-8文本转码
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnUTF8_Click(object sender, EventArgs e)
        {
            textConvert.Text = BitConverter.ToString(Encoding.UTF8.GetBytes(textConvert.Text)); 
        }
        /// <summary>
        /// base64文本编码
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnbase64_Click(object sender, EventArgs e)
        {
            textConvert.Text = Convert.ToBase64String(System.Text.Encoding.UTF8.GetBytes(textConvert.Text));
        }
    }
}
